<template>
  <div>
    <v-toolbar color="cyan" dark>
      <v-toolbar-title class="flex text-center">
        <h1>ToDo List</h1>
      </v-toolbar-title>

      <v-btn icon>
        <v-icon large @click="showAddDialog"> mdi-plus </v-icon>
      </v-btn>
    </v-toolbar>

    <v-container>
      <h1
        v-if="!tasks.length"
        class="text-center grey--text text--darken-1 pt-6"
      >
        Pulse + to create a task
      </h1>
      <v-list flat two-line>
        <v-list-item-group multiple>
          <draggable
            v-model="tasks"
            group="todoList"
            @start="drag = true"
            @end="drag = false"
          >
            <ItemListTask
              v-for="task in tasks"
              :key="task.id"
              :task="task"
              v-on:delete="deleteTask"
              v-on:dialog="showEditDialog"
              v-on:done="doneTask"
            />
          </draggable>
        </v-list-item-group>
      </v-list>
    </v-container>

    <DialogTask
      v-if="showDialog"
      v-model="showDialog"
      :isNewTask="isNewTask"
      :task="task"
      v-on:edit="editTask"
      v-on:add="addTask"
    />
  </div>
</template>


<script>
import DialogTask from "../components/DialogTask.vue";
import ItemListTask from "../components/ItemListTask.vue";
import draggable from "vuedraggable";

export default {
  name: "TodoList",
  components: {
    DialogTask,
    ItemListTask,
    draggable,
  },
  data: () => ({
    showDialog: false,
    lastId: 2,
    isNewTask: true,
    task: {
      id: -1,
      title: "",
      description: "",
      done: false,
    },
    tasks: [
      {
        id: 0,
        title: "Pool",
        description: "Change the pool's water",
        done: false,
      },
      {
        id: 1,
        title: "App",
        description: "Make todo list App",
        done: true,
      },
    ],
  }),
  methods: {
    doneTask(id) {
      let task = this.tasks.filter((task) => task.id === id)[0];
      task.done = !task.done;
      this.orderArray();
    },
    deleteTask(id) {
      this.tasks = this.tasks.filter((task) => task.id !== id);
    },
    addTask(task) {
      let newTask = {
        id: this.lastId,
        title: task.title,
        description: task.description,
        done: false,
      };
      this.lastId++;
      this.tasks.push(newTask);
      this.orderArray();
    },
    editTask(taskEdit) {
      let task = this.tasks.filter((task) => task.id === taskEdit.id)[0];
      task.title = taskEdit.title;
      task.description = taskEdit.description;
    },
    showEditDialog(task) {
      this.task = task;
      this.isNewTask = false;
      this.showDialog = true;
    },
    showAddDialog() {
      this.task = undefined;
      this.isNewTask = true;
      this.showDialog = true;
    },
    orderArray() {
      this.tasks.sort((a, b) => {
        if (a.done == b.done) return 0;
        else if (a.done) {
          if (b.done) return 0;
          else return 1;
        } else if (a.done == false) {
          if (b.done) return -1;
          else return 0;
        }
      });
    },
  },
};
</script>

